/**
 * @file
 * Handles asynchronous requests,validations,saving and updating data of CONNECT form Groups
 *  and pledgeTV channel groups
 */
(function ($, Drupal) {
  'use strict';
  // Code that uses jQuery's $ can follow here.
  $("#cnpc-account-settings-form").find("input[type='submit']").val("Verify");
  $(".nickname-div").hide();
  
  /**
   * This event handles the Click & Pledge account Form
   * it will authenticate the account id and GUID with CONNECT platform
   * after successful authentication it will gives a nickname or friendly name
   * all the information guid,accountId, nickname will be saved in table
   */
  $("#cnpc-account-settings-form").find("input[type='submit']").click(function (e) {
    if ($("#response_cnpc").val() == "") {
      e.preventDefault();
    }
    var accGuid = $("#cnpc_account_guid").val();
    var accNum = $("#cnpc_account_number").val();
    if (accNum.trim() == "") {
      $("#cnpc_account_number").css("border", "1px solid red");
      return false;
    }
    if (accGuid.trim() == "") {
      $("#cnpc_account_guid").css("border", "1px solid red");
      return false;
    }
    if (accGuid.trim() != "" && accNum.trim() != "") {
      var basePath = $("#base_url_cnpc").val();
      var url = location.protocol + "//" + location.host + basePath + "admin/cnpconnect/check/" + accNum + "/" + accGuid;
      $.ajax({
        url: url,
        type: 'GET',
        success: function (res) {
          if (res.status != null) {
            $(".nickname-div").show();
            $("#response_cnpc").val(res.status);
            $("#nickname_cnpc").val(res.status);
            $("#cnpc-account-settings-form").find("input[type='submit']").val("Save");
          } else {
            alert("Unable to find account details");
            $(".nickname-div").hide();
            $("#response_cnpc").val("");
            $("#nickname_cnpc").val("");
            $("#cnpc-account-settings-form").find("input[type='submit']").val("Verify");
          }
        },
      });
    }
  });
  
  /**
   * to hide the error information, when both fields are filled with values
   */
  $("#cnpc_account_guid").blur(function () {
    if ($(this).val().trim() != "") {
      $("#cnpc_account_guid").removeAttr("style");
    }
  });
  $("#cnpc_account_number").blur(function () {
    if ($(this).val().trim() != "") {
      $("#cnpc_account_number").removeAttr("style");
    }
  });
  
  /**
   * Actions to be performed when document loads
   */
  $(document).ready(function () {
    $('#table_id').DataTable();
    $('#table_form_group').DataTable();
    $('#table_viewforms').DataTable();
    $(".cnpc-edit-channel-group").attr('autocomplete', 'off');
    $(".cnpcaccount-add-channel-group").attr('autocomplete', 'off');
    $(".cnpcaccount-add-form-group").attr('autocomplete', 'off');
    $(".cnpc-edit-form-group").attr('autocomplete', 'off');
    $(".cnpc-account-settings-form").attr('autocomplete', 'off');
    if ($("#cnpc_action").val() == "edit") {
      $(".cnpcstartdate").each(function () {
        $(this).datetimepicker({
          timeFormat: 'hh:mm tt',
          dateFormat: 'MM dd, yy',
        });
      });
      $(".cnpcenddate").each(function () {
        $(this).datetimepicker({
          timeFormat: 'hh:mm tt',
          dateFormat: 'MM dd, yy',
        });
      });
      $(".chnlstartdate").each(function () {
        $(this).datetimepicker({
          timeFormat: 'hh:mm tt',
          dateFormat: 'MM dd, yy',
        });
      });
      $(".chnlenddate").each(function () {
        $(this).datetimepicker({
          timeFormat: 'hh:mm tt',
          dateFormat: 'MM dd, yy',
        });
      });
      $(".cnpc_form_list").each(function () {
        var opttext = $(this).data("opttext");
        var elementID = $(this).attr("id");
        $("#" + elementID + " option").each(function () {
          if ($(this).text() == opttext) {
            $(this).attr("selected", "selected");
          }
          if ($(this).text() == "Select Form Name") {
            $(this).val("");
          }
        });
      });
      $(".cnpc_camp_list").each(function () {
        var opttext = $(this).data("opttext");
        var elementID = $(this).attr("id");
        $("#" + elementID + " option").each(function () {
          if ($(this).val() == opttext) {
            $(this).attr("selected", "selected");
          }
        });
        $("#" + elementID + " option").each(function () {
          if ($(this).text() == "Select Campaign Name") {
            var Otext = $(this).text();
            $(this).val("");
          } else {
            var Otext = $(this).text() + " (" + $(this).val() + ")";
          }
          $(this).text(Otext);
        });
      });
      $(".cnpc_camp_list").each(function () {
        if ($(this).val() == "") {
          $("#cnpc_form_list_" + $(this).attr("data-rowindex")).val("");
          $("#cnpc_form_list_" + $(this).attr("data-rowindex") + " option").remove();
          $("#formguid_" + $(this).attr("data-rowindex")).val("");
        }
      });
      $(".cnpc_chnl_list").each(function () {
        var opttext = $(this).data("opttext");
        var elementID = $(this).attr("id");
        $("#" + elementID + " option").each(function () {
          if ($(this).val() == opttext) {
            $(this).attr("selected", "selected");
          }
        });
        $("#" + elementID + " option").each(function () {
          if ($(this).text() == "Select Channel Name") {
            var Otext = $(this).text();
            $(this).val("");
          } else {
            var Otext = $(this).text() + " (" + $(this).val() + ")";
          }
          $(this).text(Otext);
        });
      });
      var hidden_accid = $("#cnpc_accounts_hidden").val();
      $("#cnpc_accounts").each(function () {
        var elementID = $(this).attr("id");
        $("#" + elementID + " option").each(function () {
          var hid = $(this).val().split("||");
          if (hid[0] == hidden_accid) {
            $(this).attr("selected", "selected");
          }
        });
      });

      if ($('#custrows tr').length - 1 >= 2) {
        $(".deleteRec").show();
      }
      if ($('#custchnlrows tr').length - 1 >= 2) {
        $(".deleteRec").show();
      }
    }
    $("#start_date_time").datetimepicker({
      timeFormat: 'hh:mm tt',
      dateFormat: 'MM dd, yy',
    });
    $("#end_date_time").datetimepicker({
      timeFormat: 'hh:mm tt',
      dateFormat: 'MM dd, yy',
    });
    if ($("#cnpc_link_type").val() == "image") {
      $(".form-item-files-cnpc-upload-image").show();
      $(".form-item-cnpc-buton-label").hide();
    } else {
      $(".form-item-files-cnpc-upload-image").hide();
      $(".form-item-cnpc-buton-label").show();
    }
    
    /**
     * trimming fields and removing the HTML tags
     */
    $('.cnpcaccount-add-form-group input[type="text"]').unbind('blur').bind('blur', function () {
      removeHTMLTags($(this));
      var a = $(this).val().trim();
      $(this).val(a);
    });
    $('.cnpc-edit-form-group input[type="text"]').unbind('blur').bind('blur', function () {
      removeHTMLTags($(this));
      var a = $(this).val().trim();
      $(this).val(a);
    });
    $('.cnpcaccount-add-channel-group input[type="text"]').unbind('blur').bind('blur', function () {
      removeHTMLTags($(this));
      var a = $(this).val().trim();
      $(this).val(a);
    });
    $('.cnpc-edit-channel-group input[type="text"]').unbind('blur').bind('blur', function () {
      removeHTMLTags($(this));
      var a = $(this).val().trim();
      $(this).val(a);
    });
    $('#cnpc_message').unbind('blur').bind('blur', function () {
      var a = $(this).val().trim();
      $(this).val(a);
    });
    $('#cnpc_account_number').unbind('blur').bind('blur', function () {
      removeHTMLTags($(this));
      var a = $(this).val().trim();
      $(this).val(a);
    });
    $('#cnpc_account_guid').unbind('blur').bind('blur', function () {
      removeHTMLTags($(this));
      var a = $(this).val().trim();
      $(this).val(a);
    });
    $("textarea[name='cnpc_params_textarea']").unbind('blur').bind('blur', function () {
      removeHTMLTags($(this));
      var a = $(this).val().trim();
      $(this).val(a);
    });
    
    //hide pledge TV errors
    $("#cnpc_account_number").blur(function () {
      if ($("#cnpc_account_number").val() != "") {
        verifyAccountNumber($("#cnpc_account_number").val());
      }
    });
    
    /**
     * Hide and show error information of Form Group Name CONNECT form
     */
    $("#cnpc_form_group_name").blur(function () {
      if ($("#cnpc_form_group_name").val() != "") {
        if ($("#cnpc_action").val() == "add") {
          var fs = verifyFormGroupName($("#cnpc_form_group_name").val());
          if (fs >= 1) {
            $(".cnpc_formexists_error").html("Form group name already exist");
            $("#savebtn").attr("disabled", "disabled");
            $("#cnpc_form_group_name").focus();
          } else {
            $(".cnpc_formexists_error").html("");
            $("#savebtn").removeAttr("disabled");
          }
        } else if ($("#cnpc_action").val() == "edit") {
          if ($("#hidden_fg_name").val() != $("#cnpc_form_group_name").val()) {
            var fs = verifyFormGroupName($("#cnpc_form_group_name").val());
            if (fs >= 1) {
              $(".cnpc_formexists_error").html("Form group name already exist");
              $("#finalsave").attr("disabled", "disabled");
            } else {
              $(".cnpc_formexists_error").html("");
              $("#finalsave").removeAttr("disabled");
            }
          } else {
            $(".cnpc_formexists_error").html("");
            $("#finalsave").removeAttr("disabled");
          }
        }
      }
    });
    
    /**
     * Hide and show error information of channel group name in pledgeTV form
     */
    $("#cnpc_channel_group_name").blur(function () {
      if ($("#cnpc_channel_group_name").val() != "") {
        if ($("#cnpc_action").val() == "add") {
          var fs = verifyChannelGroupName($("#cnpc_channel_group_name").val());
          if (fs >= 1) {
            $(".cnpc_channelexists_error").html("Channel group name already exist");
            $("#chnlsavebtn").attr("disabled", "disabled");
            $("#cnpc_channel_group_name").focus();
          } else {
            $(".cnpc_channelexists_error").html("");
            $("#chnlsavebtn").removeAttr("disabled");
          }
        } else if ($("#cnpc_action").val() == "edit") {
          if ($("#hidden_fg_name").val() != $("#cnpc_channel_group_name").val()) {
            var fs = verifyChannelGroupName($("#cnpc_channel_group_name").val());
            if (fs >= 1) {
              $(".cnpc_channelexists_error").html("Channel group name already exist");
              $("#finalchnlsave").attr("disabled", "disabled");
            } else {
              $(".cnpc_channelexists_error").html("");
              $("#finalchnlsave").removeAttr("disabled");
            }
          } else {
            $(".cnpc_channelexists_error").html("");
            $("#finalchnlsave").removeAttr("disabled");
          }
        }
      }
    });
    
    /**
     * This event allows on numbers in the account number input field of settings form
     */
    $("#cnpc_account_number").keypress(function (e) {
      e = (e) ? e : window.event;
      var keyCode = (e.which) ? e.which : e.keyCode ? e.keyCode : -1;
      var ret = ((keyCode >= 48 && keyCode <= 57));
      if ((keyCode >= 48 && keyCode <= 57) || keyCode == 8) {
        return true;
      } else if (keyCode == 46) { // '.' decimal point
        var num = $(this).val();
        return false;
      }
      return false;
    });
  });
  $("#cnpc_form_group_name").blur(function () {
    $("#cnpc_form_group_name").css("border", "1px solid #b8b8b8");
  });
  if ($("#cnpc_action").val() == "edit") {
    $(".cnpc_settings_form").show();
  } else {
    $(".cnpc_settings_form").hide();
  }
  
  /**
   * When we click the save button in CONNECT form, it will display hidden div which contains 
   * campaigns information like Campaign, Form, GUID, start date, end date
   */
  $("#savebtn").click(function () {

    if (validateBasicForm()) {
      $(".cnpc_settings_form").show();
      getDataFromService($("#cnpc_counter").val());
      var tab = generateTable($("#cnpc_counter").val());
      $("tbody#dynarows").append(tab);

      $(".cnpcstartdate").each(function () {
        $(this).datetimepicker({
          timeFormat: 'hh:mm tt',
          dateFormat: 'MM dd, yy',
        });
      });
      $(".cnpcenddate").each(function () {
        $(this).datetimepicker({
          timeFormat: 'hh:mm tt',
          dateFormat: 'MM dd, yy',
        });

      });
      $("#savebtn").hide();
      $("#resetbtn").hide();
      $(".cnpc_hide_show_buttons").show();
      $("#cnpc_counter").val(1);
    }
    return false;
  });
  //add datepicker while edit form loads
  /**
   * this event adds a new row with campign details
   */
  $("#addrows").click(function (e) {
    e.preventDefault();
    var bPath = $("#base_url_cnpc").val();
    var rowIndex = parseInt($("#cnpc_counter").val());
    var downIndex = rowIndex - 1;
    if (cnpcCampListValidate() == false || cnpcFormListValidate() == false || cnpcStartDateValidate() == false || cnpcEndDateValidate() == false) {
      return false;
    }
    var rowCount = $('#custrows tr').length;
    if ($("#enddate_" + downIndex).val() == "") {
      $("#enddate_" + downIndex).next("p").remove();
      $("#enddate_" + downIndex).after("<p class='cnpctext-danger'>You must select an end date before adding another form</p>");
      return false;
    }
    if ($("#enddate_" + downIndex).val() != "") {
      $("#enddate_" + downIndex).next("p").remove();
    }
    if (validateDates(downIndex)) {
      var rows = generateTable(rowIndex);
      $("tbody#dynarows").append(rows);
      $(".cnpcstartdate").each(function () {
        $(this).datetimepicker({
          timeFormat: 'hh:mm tt',
          dateFormat: 'MM dd, yy',
        });
      });
      $(".cnpcenddate").each(function () {
        $(this).datetimepicker({
          timeFormat: 'hh:mm tt',
          dateFormat: 'MM dd, yy',
        });
      });
      if (rowCount >= 2) {
        $(".deleteRec").show();
      } else {
        $(".deleteRec").hide();
      }
      getDataFromService(rowIndex);
      $("#cnpc_counter").val(rowIndex + 1);
    } 
});
  
  /**
   * This event fires when campaigns dropdown chnages in CONNECT form
   * based on the value changes in campaign form, it will get the forms related to that campaign and updates
   * forms list under Form dropdown
   */
  $(document).on('change', '.cnpc_camp_list', function () {
    var fi = $(this).data("rowindex");
    var campId = $(this).val();
    var accguid = $("#cnpc_accounts").val();
    var ss = accguid.split("||");
    var AccId = ss[0];
    var AccGuid = ss[1];
    var finalInfo = AccId + "@" + AccGuid + "@" + campId;
    if ($(this).val() != "") {
      $(this).next("p").remove();
    }
    var basePath = $("#base_url_cnpc").val();
    var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/getactivityforms/" + finalInfo;
    $.ajax({
      type: "GET",
      url: url,
      beforeSend: function () {},
      success: function (res) {
        $("#cnpc_form_list_" + fi).html(res.data);
      },
    });
  });
  
  /**
   * this event fires on Form drop down in CONNECT Form
   * when the value changes in dropdown
   */
  $(document).on('change', '.cnpc_form_list', function () {
    var indx = $(this).data("formindex");
    var PrevIndx = $(this).data("formindex") - 1;
    var PrevEndDt = new Date($("#enddate_" + PrevIndx).val());
    $("#formguid_" + $(this).data("formindex")).val($(this).val());
    if ($(this).data("formindex") == 0) {
      $("#startdate_" + $(this).data("formindex")).val($("#start_date_time").val());
    } else {
      $("#startdate_" + indx).datepicker("setDate", addOneDayToDate(PrevEndDt));
    }
    if ($(this).val() != "") {
      $(this).next("p").remove();
    }
    if ($("#startdate_" + $(this).data("formindex")).val() != "") {
      $("#startdate_" + $(this).data("formindex")).next().remove();
    }
  });
 
 /**
  * This event handles to delete Campaigns row, 
  * this delete button enbales when we are having more than 1 form
  */
  $(document).on('click', '.deleteRec', function (e) {
    e.preventDefault();
    var cD = confirm("Are you sure want to delete?");
    if (cD == true) {
      var target = $(this).data("target");
      var recid = $(this).data("recid");
      if ($('#custrows tr').length == 3) {
        $("#cnpc_counter").val($("#cnpc_counter").val() - $(this).data("index"));
        $("#row_" + $(this).data("index")).remove();
        $(".deleteRec").hide();
      } else {
        $("#row_" + $(this).data("index")).remove();
        $("#cnpc_counter").val($("#cnpc_counter").val() - $(this).data("index"));
        $("#cnpcchnl_counter").val($("#cnpcchnl_counter").val() - $(this).data("index"));
        if ($('#custchnlrows tr').length == 2) {
          $(".deleteRec").hide();
        }
      }
      if (target == "edit") {
        var recid = $(this).data("recid");
        var cact = $(this).data("caction");
        deleteFormDetails(recid, cact);
      }
    }
  });
  
  /**
   * This event will handles URL+ button, by clicking that button opens a popup to add URL parameters
   */
  $(document).on('click', '.cnpc-myBtn', function (e) {
    e.preventDefault();
    var pos = $(this).data("index");
    var plist = $("#hidden_params_" + pos).val();
    $(".cnpc-popup-success").remove();
    var newid = "params_" + pos;
    $(".cnpc-form-group-params textarea").attr("id", newid);
    $(".cnpc-form-group-params textarea").attr("data-params-pos", pos);
    $(".cnpc-form-group-params textarea").val(plist);
    $("#addparams").attr("data-position", pos);
    $("#savecloseparams").attr("data-position", pos);
    $("#cnpc_myModal").show();
  });
  $(".cnpc-close").click(function () {
    $(".cnpc-form-group-params textarea").val("");
    $("#cnpc_myModal").hide();
  });
  $(".popupclosebtn").click(function (e) {
    e.preventDefault();
    $(".cnpc-form-group-params textarea").val("");
    $("#cnpc_myModal").hide();
  });
  $(".popupsavebtn").click(function (e) {
    e.preventDefault();
    var ppos = '';
    $(".cnpc-popup-success").remove();
    ppos = $(this).attr("data-position");
    var listParams = $("#params_" + ppos).val();
    var listParams = listParams.trim();
    if (listParams) {
      $("#hidden_params_" + ppos).val(listParams);
      $(".popupsavebtn").after("<span class='cnpc-popup-success'>Parameters added</span>");
    }
  });
  
  /**
   * This event closes the popup window of URL parameters
   */
  $(".popupsaveclosebtn").click(function (e) {
    e.preventDefault();
    var ppos = '';
    $(".cnpc-popup-success").remove();
    ppos = $(this).attr("data-position");
    var listParams = $("#params_" + ppos).val();
    var listParams = listParams.trim();
    $("#hidden_params_" + ppos).val(listParams);
    $(".cnpc-form-group-params textarea").val("");
    $("#cnpc_myModal").hide();
  });

  $("textarea[name='cnpc_params_textarea']").on("keypress", function (e) {
    removeHTMLTags($(this));
  });

  /**
   * to remove HTML tags from an input fields
   * @param {type} e
   * @returns {undefined}
   */
  function removeHTMLTags(e) {
    var val = $("#" + e.attr("id")).val();
    var val = $("#" + e.attr("id")).val();
    var regex = /(<([^>]+)>)/ig;
    var result = val.replace(regex, "");
    $("#" + e.attr("id")).val(result);
  }

  /**
   * to delete the Channel forms
   * @param {type} id
   * @param {type} cact
   * @returns {undefined}
   */
  function deleteFormDetails(id, cact) {
    var basePath = $("#base_url_cnpc").val();
    if (cact == "edittv") {
      var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/deletetvformdetails/" + id;
    } else {
      var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/deleteformdetails/" + id;
    }
    $.ajax({
      type: "GET",
      url: url,
      success: function (res) {},
      error: function (err) {},
    });
  }
  
  /**
   * to generate campaigns rows by clicking Add Form button
   * @param {type} rowIndex
   * @returns {String}
   */
  function generateTable(rowIndex) {
    var bPath = $("#base_url_cnpc").val();
    var trow = "";
    trow += "<tr id='row_" + rowIndex + "'>";
    trow += "<td>";
    trow += "<select  class='cnpc_camp_list' data-rowindex='" + rowIndex + "'  name='cnpc_camp_list[]' id='cnpc_camp_list_" + rowIndex + "'>";
    trow += "<option value=''>Select Campaign Name</option>";
    trow += "</select><img id='imgloader_" + rowIndex + "' src='" + bPath + "modules/clickandpledge_connect/images/loading.gif' height='25' width='25'>";
    trow += "</td>";
    trow += "<td>";
    trow += "<select name='cnpc_form_list[]' data-formindex='" + rowIndex + "' class='cnpc_form_list' id='cnpc_form_list_" + rowIndex + "'>";
    trow += "<option value=''>Select Form Name</option>";
    trow += "</select>";
    trow += "</td>";
    trow += "<td>";
    trow += "<input type='text' name='formguid[]' id='formguid_" + rowIndex + "' disabled='disabled'>";
    trow += "</td>";
    trow += "<td>";
    trow += "<input type='text' name='startdate[]' class='cnpcstartdate' id='startdate_" + rowIndex + "'>";
    trow += "</td>";
    trow += "<td>";
    trow += "<input type='text' name='enddate[]' class='cnpcenddate' id='enddate_" + rowIndex + "'>";
    trow += "</td>";
    trow += "<td class='cnpc_delurl_btns' id='row_" + rowIndex + "'><input type='hidden' id='hidden_params_" + rowIndex + "' name='hidden_params[]'>";
    trow += "<div class='cnpc_url_btn'><a href='javascript:void(0)' class='cnpc-myBtn' data-index='" + rowIndex + "'>URL<b>+</b></a></div> &nbsp; <div class='cnpc_delete_btn'><a title='Delete' href='javascript:void(0)' id='deleteRec_" + rowIndex + "' data-target='add' class='deleteRec' data-index='" + rowIndex + "'><span class='bin_icon'></span></a></div>";
    trow += "</td>";
    trow += "</tr>";
    return trow;
  }
 
 /**
  * to vlidate the Add CONNECT form
  * @returns {Boolean}
  */
  function hiddenFormValidate() {
    var inps1 = document.getElementsByName('cnpc_camp_list[]');
    var stopper = true;
    for (var k = 0; k < inps1.length; k++) {
      if (inps1[k].value == "") {
        alert("select Campaign list");
        stopper = false;
      }
    }
    return stopper;
  }

  /**
   * to validate the campaigns dropdown in edit CONNECT form
   * @returns {Boolean}
   */
  function cnpcCampListValidate() {
    var stopper = true;
    if ($("#cnpc_action").val() == "edit") {
      $("select[name^='cnpc_camp_list_']").each(function () {
        if ($(this).val() == "") {
          $("#" + $(this).attr("id")).next().remove();
          $("#" + $(this).attr("id")).after("<p class='cnpctext-danger'>Please select a campaign</p>");
          stopper = false;
        }
      });
    }
    var inps1 = document.getElementsByName('cnpc_camp_list[]');
    for (var k = 0; k < inps1.length; k++) {
      if (inps1[k].value == "") {
        $("#" + inps1[k].id).next().remove();
        $("#" + inps1[k].id).after("<p class='cnpctext-danger'>Please select a campaign</p>");
        stopper = false;
        break;
      }
    }
    return stopper;
  }
  
  /**
   * to validate the form drop down
   * @returns {Boolean}
   */
  function cnpcFormListValidate() {
    var stopper = true;
    if ($("#cnpc_action").val() == "edit") {
      $("select[name^='cnpc_form_list_']").each(function () {
        if ($(this).val() == "") {
          $("#" + $(this).attr("id")).next().remove();
          $("#" + $(this).attr("id")).after("<p class='cnpctext-danger'>Please select a form</p>");
          stopper = false;
        }
      });
    }
    var inps1 = document.getElementsByName('cnpc_form_list[]');
    for (var k = 0; k < inps1.length; k++) {
      if (inps1[k].value == "") {
        $("#" + inps1[k].id).next().remove();
        $("#" + inps1[k].id).after("<p class='cnpctext-danger'>Please select a form</p>");
        stopper = false;
        break;
      }
    }
    return stopper;
  }
  
  /**
   * to validate the start date of CONNECT form
   * @returns {Boolean}
   */
  function cnpcStartDateValidate() {
    var stopper = true;
    if ($("#cnpc_action").val() == "edit") {
      $("select[name^='startdate_']").each(function () {
        if ($(this).val() == "") {
          $("#" + $(this).attr("id")).next().remove();
          $("#" + $(this).attr("id")).after("<p class='cnpctext-danger'>Please select a start date</p>");
          stopper = false;
        }
      });
    }
    var inps1 = document.getElementsByName('startdate[]');
    for (var k = 0; k < inps1.length; k++) {
      if (inps1[k].value == "") {
        $("#" + inps1[k].id).next().remove();
        $("#" + inps1[k].id).after("<p class='cnpctext-danger'>Please select a start date</p>");
        stopper = false;
        break;
      }
    }
    return stopper;
  }

  /**
   * to validate the end date of CONNECT form
   * @returns {Boolean}
   */
  function cnpcEndDateValidate() {
    var stopper = true;
    if ($("#cnpc_action").val() == "edit") {
      $("select[name^='enddate_']").each(function () {
        if ($(this).val() == "") {
          $("#" + $(this).attr("id")).next().remove();
          $("#" + $(this).attr("id")).after("<p class='cnpctext-danger'>Please select a end date</p>");
          stopper = false;
        }
      });
    }
    var inps1 = document.getElementsByName('enddate[]');
    for (var k = 0; k < inps1.length; k++) {
      if (k != 0) {
        if (inps1[k].value == "") {
          if (k == (inps1.length - 1)) {
            stopper = true;
          } else {
            $("#" + inps1[k].id).next().remove();
            $("#" + inps1[k].id).after("<p class='cnpctext-danger'>Please select a end date</p>");
            stopper = false;
            break;
          }
        }
      }
    }
    return stopper;
  }
  /**
   * to get the list of Campaigns under an account
   * @param {type} ind
   * @returns {undefined}
   */
  function getDataFromService(ind) {
    var accguid = $("#cnpc_accounts").val();
    var obj = accguid.split("||");
    let accid = obj[0];
    let guid = obj[1];
    let finalguid = accid + "@" + guid;
    var basePath = $("#base_url_cnpc").val();
    var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/getcampaigns/" + finalguid;
    $.ajax({
      type: "GET",
      url: url,
      beforeSend: function () {
        $("#imgloader_" + ind).show();
      },
      success: function (res) {
        $("#cnpc_camp_list_" + ind).html(res.data);
        $("#imgloader_" + ind).hide();
      },
      error: function (err) {
          alert("unable to get campaigns")
      },
    });
  }
  
  /**
   * this event handles to save the CONNECT form information
   * internall it calls vlidateBasicForm to validate form details like groupname,start&end dates
   * once click the save button it will opens Campaign forms. where we can click Add Forms button to add multiple 
   * forms to the group
   */
  $("#finalsave").click(function () {
    if (!validateBasicForm()) {
      return false;
    }
    var stdt = $("#start_date_time").val();
    var eddt = $("#end_date_time").val();
    var greg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
    if (stdt.match(greg)) {
      var gres = stdt.split(" ");
      var gres1 = gres[0].split("/");
      var gres2 = gres1[1] + "/" + gres1[0] + "/" + gres1[2];
      stdt = gres2 + " " + gres[1] + " " + gres[2];
    }
    if (eddt != "") {
      if (eddt.match(greg)) {
        var gcres = eddt.split(" ");
        var gcres1 = gcres[0].split("/");
        var gcres2 = gcres1[1] + "/" + gcres1[0] + "/" + gcres1[2];
        eddt = gcres2 + " " + gcres[1] + " " + gcres[2];
      }
    }
    var mstdt = new Date(stdt);
    var meddt = new Date(eddt);
    var campfldnm;
    var frmfldnm;
    var guidfldnm;
    var chksdt = $("#start_date_time").val();
    var chkedt = $("#end_date_time").val()
    var reg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
    if (chksdt.match(reg)) {
      var res = chksdt.split(" ");
      var res1 = res[0].split("/");
      var res2 = res1[1] + "/" + res1[0] + "/" + res1[2];
      chksdt = res2 + " " + res[1] + " " + res[2];
    }
    if (chkedt != "") {
      if (chkedt.match(reg)) {
        var cres = chkedt.split(" ");
        var cres1 = cres[0].split("/");
        var cres2 = cres1[1] + "/" + cres1[0] + "/" + cres1[2];
        chkedt = cres2 + " " + cres[1] + " " + cres[2];
      }
    }
    var mchksdt = new Date(chksdt);
    var mchkedt = new Date(chkedt);
    if ($("#start_date_time").val() == "") {
      $("#start_date_time").addClass("cnpcform-invalid");
      $("#start_date_time").focus();
      return false;
    }
    if (chksdt != "" && chkedt != "") {
      if (mchksdt.getTime() > mchkedt.getTime()) {
        $("#end_date_time").addClass("cnpcform-invalid");
        $("#end_date_time").focus();
        return false;
      }
    }
    //display type validation
    if ($("#cnpc_display_type").val() == "") {
      $("#cnpc_display_type").addClass("cnpcform-invalid");
      $("#cnpc_display_type").focus();
      return false;
    }
    if ($("#cnpc_display_type").val() == "popup" && $("#cnpc_link_type").val() == "") {
      $("#cnpc_link_type").addClass("cnpcform-invalid");
      return false;
    }
    if ($("#cnpc_display_type").val() == "popup" && ($("#cnpc_display_type").val() == "text" || $("#cnpc_display_type").val() == "button") && $("#cnpc_btn_lbl").val() == "") {
      $("#cnpc_btn_lbl").addClass("cnpcform-invalid");
      return false;
    }
    var form_data = new FormData();
    var formAction = $("#cnpc_action").val();
    var camp = cnpcCampListValidate();
    var form = cnpcFormListValidate();
    var sdate = cnpcStartDateValidate();
    var edate = cnpcEndDateValidate();
    var nofrms = $("#cnpc_counter").val();
    nofrms = nofrms - 1;
    for (var j = 0; j <= nofrms; j++) {
      var strtdt1 = $("#startdate_" + j).val();
      var chkedt1 = $("#enddate_" + j).val();
      var ereg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
      if (strtdt1.match(ereg)) {
        var eres = strtdt1.split(" ");
        var eres1 = eres[0].split("/");
        var eres2 = eres1[1] + "/" + eres1[0] + "/" + eres1[2];
        strtdt1 = eres2 + " " + eres[1] + " " + eres[2];
      }
      if (chkedt1 != "") {
        if (chkedt1.match(ereg)) {
          var ecres = chkedt1.split(" ");
          var ecres1 = ecres[0].split("/");
          var ecres2 = ecres1[1] + "/" + ecres1[0] + "/" + ecres1[2];
          chkedt1 = ecres2 + " " + ecres[1] + " " + ecres[2];
        }
      }
      var mchksdt1 = new Date(strtdt1);
      var mchkedt1 = new Date(chkedt1);
      if (strtdt1 != "" && chkedt1 == "") {
        if (mchksdt1.getTime() < mstdt.getTime()) {
          $("#startdate_" + j).next().remove();
          $("#startdate_" + j).after("<p class='cnpc-danger'>Form start date should be greater or equal to group start date</p>");
          $("#startdate_" + j).focus();
          return false;
        }
        if (mchksdt1.getTime() > meddt.getTime()) {
          $("#startdate_" + j).next().remove();
          $("#startdate_" + j).after("<p class='cnpc-danger'>Form start date should be less than or equal to group end date</p>");
          $("#startdate_" + j).focus();
          return false;
        }
      }
      if (strtdt1 != "" && chkedt1 != "") {
        if (mchkedt1.getTime() > meddt.getTime()) {
          $("#enddate_" + j).next().remove();
          $("#enddate_" + j).after("<p class='cnpc-danger'>Form end date should be less than or equal to group end date</p>");
          $("#enddate_" + j).focus();
          return false;
        }
        if (mchksdt1.getTime() < mstdt.getTime()) {
          $("#startdate_" + j).next().remove();
          $("#startdate_" + j).after("<p class='cnpc-danger'>Form start date should be greater or equal to group start date</p>");
          $("#startdate_" + j).focus();
          return false;
        }
        if (mchksdt1.getTime() > mchkedt1.getTime()) {
          $("#enddate_" + j).next().remove();
          $("#enddate_" + j).after("<p class='cnpc-danger'>End date should be greater than or equal to start date</p>");
          $("#enddate_" + j).focus();
          return false;
        }
      }
    }
    if (camp && form && sdate && edate) {
      var cnpcfgn = $("#cnpc_form_group_name").val();
      var cnpcacc = $("#cnpc_accounts").val();
      var cnpcsdt = $("#start_date_time").val();
      var cnpcedt = $("#end_date_time").val();
      var cnpcdtype = $("#cnpc_display_type").val();
      form_data.append('cnpc_action', formAction);
      form_data.append('cnpc_group_name', cnpcfgn);
      form_data.append('cnpc_account', cnpcacc);
      form_data.append('cnpc_start_datetime', cnpcsdt);
      form_data.append('cnpc_end_datetime', cnpcedt);
      form_data.append('cnpc_display_type', cnpcdtype);
      if (cnpcdtype == "popup") {
        var cnpcltype = $("#cnpc_link_type").val();
        form_data.append('link_type', cnpcltype);
        if (cnpcltype == "image") {
          var filepath = $("#cnpc_upload_image").val();
          var files = document.getElementById('cnpc_upload_image').files;
          if (files.length != 0) {
            if (files[0].type == "image/png" || files[0].type == "image/jpg" || files[0].type == "image/jpeg") {
              form_data.append('file', files[0]);
            } else {
              alert("Please select a valid image(.png, .jpg)");
              $("#cnpc_upload_image").focus();
              return false;
            }
          } else {
            if ($("#cnpc_action").val() == "edit") {
              if($("#cnpc_upload_image_hidden").val()!="")
              {
                var hiddenImg = $("#cnpc_upload_image_hidden").val();
                form_data.append('file', hiddenImg);
              }
              else
              {
                $("#cnpc_upload_image").css("border", "1px solid red");
                $("#cnpc_upload_image").focus();
                return false;
              }
            } else {
              alert("Please select an image");
              $("#cnpc_upload_image").focus();
              return false;
            }
          }
        } else {
          var btnlbl = $("#cnpc_btn_lbl").val();
          var linktype = $("#cnpc_link_type").val();
          form_data.append('link_type', linktype);
          if (btnlbl != "") {
            form_data.append('button_label', btnlbl);
          } else {
            alert("Please enter button label");
            $("#cnpc_btn_lbl").focus();
            return false;
          }
        }
      }
      var cmpcmsg = $("#cnpc_message").val();
      var status = $("#cnpc_status").val();
      form_data.append('cnpc_message', cmpcmsg);
      form_data.append('cnpc_status', status);
      var basePath = $("#base_url_cnpc").val();
      var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/saveformdata/";
      //collect the data from groups
      if (formAction == "add") {
        var camp_list = getValues("cnpc_camp_list[]");
        var form_list = getValues("cnpc_form_list[]");
        var form_list_titles = getTitles("cnpc_form_list[]");
        var formguid = getValues("formguid[]");
        var startdate = getValues("startdate[]");
        var enddate = getValues("enddate[]");
        var paramsList = getValues("hidden_params[]");
      } else {
        var camp_list = getFormSelectValues("cnpc_camp_list");
        var form_list = getFormSelectValues("cnpc_form_list");
        var form_list_titles = getSelectTitles("cnpc_form_list");
        var formguid = getFormValues("formguid");
        var startdate = getFormValues("startdate");
        var enddate = getFormValues("enddate");
        var cnpc_edit_id = $("#cnpc_edit_id").val();
        var paramsList = getFormValues("hidden_params");
        form_data.append("cnpc_edit_id", cnpc_edit_id);
      }
      form_data.append("cnpc_camp_list", camp_list);
      form_data.append("cnpc_form_list", form_list);
      form_data.append("formguid", formguid);
      form_data.append("startdate", startdate);
      form_data.append("enddate", enddate);
      form_data.append("form_list_titles", form_list_titles);
      form_data.append("params_list", paramsList);
      $.ajax({
        url: url,
        data: form_data,
        cache: false,
        contentType: false,
        method: 'POST',
        processData: false,
        dataType: 'json',
        success: function (res) {
          if (res.data == "success") {
            if (formAction == "edit") {
              window.location = "../cnp_form";
            } else {
              window.location = "cnp_form";
            }
          }
          return false;
        },
      });
    }
    return false;
  });
  
  /**
   * read all the values of a campaign
   * @param {type} name
   * @returns {String}
   */
  function getValues(name) {
    var fdata = "";
    var inps = document.getElementsByName(name);
    for (var i = 0; i < inps.length; i++) {
      var inp = inps[i];
      fdata += inp.value + "###";
    }
    return fdata;
  }
  /**
   * get the form values
   * @param {type} name
   * @returns {String}
   */
  function getFormValues(name) {
    var fvdata = '';
    $("input[name^='" + name + "']").each(function () {
      fvdata += $("#" + $(this).attr("id")).val() + "###";
    });
    return fvdata;
  }
  
  /**
   * get the form selected values
   * @param {type} name
   * @returns {String}
   */
  function getFormSelectValues(name) {
    var fsdata = '';
    $("select[name^='" + name + "']").each(function () {
      fsdata += $("#" + $(this).attr("id")).val() + "###";
    });
    return fsdata;
  }

   /**
    * to get all the option titles from a dropdowns which are selected and concatinate them into a variable to return
    * @param {type} name
    * @returns {String}
    */
  function getSelectTitles(name) {
    var ftitles = "";
    $("select[name^='" + name + "']").each(function () {
      ftitles += $('#' + $(this).attr("id") + ' option:selected').text() + "###";
    });
    return ftitles;
  }

  /**
   * to get the name of the option selected in a dropdown
   * @param {type} name
   * @returns {String}
   */
  function getTitles(name) {
    var fdata = "";
    var inps = document.getElementsByName(name);
    for (var i = 0; i < inps.length; i++) {
      var inp = inps[i];
      fdata += $('#' + inp.id + ' option:selected').text() + "###";
    }
    return fdata;
  }


  /**
   * to get the current date in required format - January 23, 2020 07:26 am
   * @returns {String}
   */
  function getCurrentDate() {
    const monthNames = ["January", "February", "March", "April", "May", "June",
      "July", "August", "September", "October", "November", "December"
    ];
    var d = new Date();
    var n = d.getMonth();
    var dt = monthNames[d.getMonth()];
    var day = d.getDate();
    if (day <= 9) {
      day = "0" + day;
    }
    return dt + " " + day + ", " + d.getFullYear() + " " + formatAMPM(new Date);
  }

/**
 * the below function adds 1 day to the date passed as parameter
 * @param {type} dateStr
 * @returns {String}
 */
  function addOneDayToDate(dateStr) {
    const monthNames = ["January", "February", "March", "April", "May", "June",
      "July", "August", "September", "October", "November", "December"
    ];
    var days = 1;
    var result = new Date(new Date(dateStr).setMinutes(new Date(dateStr).getMinutes() + 1));
    var d = result;
    var n = d.getMonth();
    var dt = monthNames[d.getMonth()];
    var day = d.getDate();
    if (day <= 9) {
      day = "0" + day;
    }
    return dt + " " + day + ", " + d.getFullYear() + " " + formatAMPM(dateStr);
  }

  /**
   * to calculate AM or PM based on the date passed.
   * @param {type} date
   * @returns {String}
   */
  function formatAMPM(date) {
    var hours = date.getHours();
    var minutes = date.getMinutes() + 1;
    var ampm = hours >= 12 ? 'pm' : 'am';
    hours = hours % 12;
    hours = hours ? hours : 12; // the hour '0' should be '12'
    minutes = minutes < 10 ? '0' + minutes : minutes;
    var strTime = hours + ':' + minutes + ' ' + ampm;
    return strTime;
  }
  
  if ($("#cnpc_display_type").val() == "popup") {
    $(".overlay_wrapper").show();
  } else {
    $(".overlay_wrapper").hide();
  }
  
  /**
   * This event handles Display type in the CONNECT forms dropdown
   * default display type is inline
   */
  $("#cnpc_display_type").change(function () {
    if ($(this).val() == "popup") {
      $(".overlay_wrapper").show();
    } else {
      $(".overlay_wrapper").hide();
    }
  });
  
  /**
   * This event handles Link type in the CONNECT forms dropdown
   * default display type is button
   */
  $("#cnpc_link_type").change(function () {
    if ($(this).val() == "image") {
      $(".form-item-files-cnpc-upload-image").show();
      $(".form-item-cnpc-buton-label").hide();
    } else {
      $(".form-item-files-cnpc-upload-image").hide();
      $(".form-item-cnpc-buton-label").show();
    }
  });

  /**
   * This method validates the start date and End date of CONNECT form group
   * we can not select previous date of current date
   * start date and end date should be greater than the current date always
   * end date should not below the start date
   * @param {type} j
   * @returns {Boolean}
   */
  function validateDates(j) {
    var status = true;
    var strtdt1 = $("#startdate_" + j).val();
    var chkedt1 = $("#enddate_" + j).val();
    var stdt = $("#start_date_time").val();
    var eddt = $("#end_date_time").val();
    var greg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
    if (stdt.match(greg)) {
      var gres = stdt.split(" ");
      var gres1 = gres[0].split("/");
      var gres2 = gres1[1] + "/" + gres1[0] + "/" + gres1[2];
      stdt = gres2 + " " + gres[1] + " " + gres[2];
    }
    if (eddt != "") {
      if (eddt.match(greg)) {
        var gcres = eddt.split(" ");
        var gcres1 = gcres[0].split("/");
        var gcres2 = gcres1[1] + "/" + gcres1[0] + "/" + gcres1[2];
        eddt = gcres2 + " " + gcres[1] + " " + gcres[2];
      }
    }
    var mstdt = new Date(stdt);
    var meddt = new Date(eddt);
    var ereg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
    if (strtdt1.match(ereg)) {
      var eres = strtdt1.split(" ");
      var eres1 = eres[0].split("/");
      var eres2 = eres1[1] + "/" + eres1[0] + "/" + eres1[2];
      strtdt1 = eres2 + " " + eres[1] + " " + eres[2];
    }
    if (chkedt1 != "") {
      if (chkedt1.match(ereg)) {
        var ecres = chkedt1.split(" ");
        var ecres1 = ecres[0].split("/");
        var ecres2 = ecres1[1] + "/" + ecres1[0] + "/" + ecres1[2];
        chkedt1 = ecres2 + " " + ecres[1] + " " + ecres[2];
      }
    }
    var mchksdt1 = new Date(strtdt1);
    var mchkedt1 = new Date(chkedt1);
    if (strtdt1 != "" && chkedt1 == "") {
      if (mchksdt1.getTime() < mstdt.getTime()) {
        $("#startdate_" + j).next().remove();
        $("#startdate_" + j).after("<p class='cnpc-danger'>Form start date should be greater or equal to group start date</p>");
        $("#startdate_" + j).focus();
        status = false;
      }
      if (mchksdt1.getTime() > meddt.getTime()) {
        $("#startdate_" + j).next().remove();
        $("#startdate_" + j).after("<p class='cnpc-danger'>Form start date should be less than or equal to group end date</p>");
        $("#startdate_" + j).focus();
        status = false;
      }
    }
    if (strtdt1 != "" && chkedt1 != "") {
      if (mchkedt1.getTime() > meddt.getTime()) {
        $("#enddate_" + j).next().remove();
        $("#enddate_" + j).after("<p class='cnpc-danger'>Form end date should be less than or equal to group end date</p>");
        $("#enddate_" + j).focus();
        status = false;
      }
      if (mchksdt1.getTime() < mstdt.getTime()) {
        $("#startdate_" + j).next().remove();
        $("#startdate_" + j).after("<p class='cnpc-danger'>Form start date should be greater or equal to group start date</p>");
        $("#startdate_" + j).focus();
        status = false;
      }
      if (mchksdt1.getTime() > mchkedt1.getTime()) {
        $("#enddate_" + j).next().remove();
        $("#enddate_" + j).after("<p class='cnpc-danger'>End date should be greater than or equal to start date</p>");
        $("#enddate_" + j).focus();
        status = false;
      }
    }
    return status;
  }
  
  /**
   * the below event handles CONNECT form status as active or inactive
   * active forms will be dispay on pages, inactive forms will not display in pages
   * 
   */
  var fstatus;
  $(".formstatus").click(function (event) {
    event.preventDefault();
    var elemID = $(this).attr("id");
    if ($(this).html() == "active") {
      fstatus = "inactive";
      $(this).html(fstatus);
    } else if ($(this).html() == "inactive") {
      fstatus = "active";
      $(this).html(fstatus);
    }
    var gid = $(this).data("fgid");
    var basePath = $("#base_url_cnpc").val();
    var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/updateFormStatus/" + fstatus + "/" + gid;
    $.ajax({
      url: url,
      type: "GET",
      success: function (res) {
        if (res.data === "success") {}
      },
      error: function (err) {
        alert("Unable to update form status")
      },
    });
  });
  
  /**
   * the below event handles channel form status as active or inactive
   * active forms will be dispay on pages, inactive form will not display in pages
   */
  var fstatus;
  $(".ptvformstatus").click(function (event) {
    event.preventDefault();
    var elemID = $(this).attr("id");

    if ($(this).html() == "active") {
      fstatus = "inactive";
      $(this).html(fstatus);
    } else if ($(this).html() == "inactive") {
      fstatus = "active";
      $(this).html(fstatus);
    }
    var gid = $(this).data("fgid");
    var basePath = $("#base_url_cnpc").val();
    var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/updatepTVFormStatus/" + fstatus + "/" + gid;
    $.ajax({
      url: url,
      type: "GET",
      success: function (res) {
        if (res.data == "success") {
          $("#" + elemID).html(fstatus);
          $("#" + elemID).attr("data-fstatus", fstatus);
        }
      },
      error: function (err) {},
    });
  });
  
  /**
   * Delete a form from CONNECT from group
   */
  $(".deleteFormInfo").click(function (e) {
    e.preventDefault();
    var did = $(this).data("recid");
    var basePath = $("#base_url_cnpc").val();
    var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/deleteform/" + did;
    $.ajax({
      url: url,
      type: "GET",
      success: function (res) {
        if (res.data === "success") {
          window.location = "cnp_form";
        } else {
          window.location = "cnp_form";
        }
      },
      error: function (err) {
        alert("Unable to delete form information");
      },
    });
  });
  
  /**
   * This event handles the to delete the settings information from account settings table under settings tab
   */
  $(".settingsDel").click(function (e) {
    e.preventDefault();
    var setdid = $(this).data("settrecid");
    var basePath = $("#base_url_cnpc").val();
    var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/deletesettings/" + setdid;
    $.ajax({
      url: url,
      type: "GET",
      success: function (res) {
        if (res.data == "success") {
          var date = new Date();
          date.setTime(date.getTime() + (3 * 1000));
          $.cookie('settingsdel', "Account Deleted Successfully", {
            expires: date
          });
          window.location = "cnp_formssettings";
        } else {
          $(".cnpc_error_msg").show();
          $(".cnpc_error_msg").addClass("cnpc_error");
          $(".cnpc_error_msg").html("This Account Number is associated with an existing form group. You must first delete the form group before deleting this account.");
        }
      },
      error: function (err) {
        alert("unable to process");
      },
    });
  });

  /**
   * Reads the cookie information
   * @param {type} name
   * @returns {unresolved}
   */
  function readCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
      var c = ca[i];
      while (c.charAt(0) == ' ') c = c.substring(1, c.length);
      if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
    }
    return null;
  }
  if (readCookie("settingsdel")) {
    $(".cnpc_error_msg").show();
    $(".cnpc_error_msg").focus();
    $(".cnpc_error_msg").addClass("cnpc_success");
    $(".cnpc_error_msg").html(decodeURI(readCookie("settingsdel")));
  }
  
  /**
   * This event helps to get updated data from the CONNECT platform
   */
  $(".refreshAccounts").click(function (e) {
    e.preventDefault();
    var check = confirm("I am refreshing the account information, please wait");
    if (check == true) {
      var settguid = $(this).data('settguid');
      var settaccid = $(this).data('settaccid');
      var recid = $(this).data('settid');
      var basePath = $("#base_url_cnpc").val();
      var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/refreshaccounts/";
      $.ajax({
        url: url,
        type: "POST",
        data: {
          sguid: settguid,
          saccid: settaccid,
          srecid: recid
        },
        success: function (res) {
          if (res.data == "success") {
            alert("All account information has been updated.  Please click OK to continue.");
            window.location = "cnp_formssettings";
          } else {
            alert("All account information has been updated.  Please click OK to continue.");
            window.location = "cnp_formssettings";
          }
        },
        error: function (err) {
          alert("Unable to refresh accounts");
        },
      });
    }
  });
  
  /**
   * This change event handles on Accounts drop down in both forms(CONNECT and pledgeTV)
   * when we chnage the account it will clear all entered data, because it load the fresh data of the selected account
   */
  $("#cnpc_accounts").change(function () {
    //Form Acocunts change
    if ($("#cnpc_counter").val() >= 1) {
      var clr = confirm("Changing the account will clear all entered data. Are you sure?");
      if (clr == true) {
        $("#cnpc_counter").val(0);
        $("#custrows").find("tr:gt(0)").remove();
        getDataFromService($("#cnpc_counter").val());
        var tab = generateTable($("#cnpc_counter").val());
        $("tbody#dynarows").append(tab);

        $(".cnpcstartdate").each(function () {
          $(this).datetimepicker({
            timeFormat: 'hh:mm tt',
            dateFormat: 'MM dd, yy',
          });
        });
        $(".cnpcenddate").each(function () {
          $(this).datetimepicker({
            timeFormat: 'hh:mm tt',
            dateFormat: 'MM dd, yy',
          });
        });
        $("#cnpc_counter").val(1);
      }
    }
    //pledgeTV Accounts Change
    if ($("#cnpcchnl_counter").val() >= 1) {
      var clr = confirm("Changing the account will clear all entered data. Are you sure?");
      if (clr == true) {
        $("#cnpcchnl_counter").val(0);
        $("#custchnlrows").find("tr:gt(0)").remove();
        getDataChannelService($("#cnpcchnl_counter").val());
        var tab = generateChannelTable($("#cnpcchnl_counter").val());
        $("tbody#dynachnlrows").append(tab);
        $(".cnpcstartdate").each(function () {
          $(this).datetimepicker({
            timeFormat: 'hh:mm tt',
            dateFormat: 'MM dd, yy',
          });
        });
        $(".cnpcenddate").each(function () {
          $(this).datetimepicker({
            timeFormat: 'hh:mm tt',
            dateFormat: 'MM dd, yy',
          });
        });
        $("#cnpcchnl_counter").val(1);
      }
    }
  });
  /**************************************************************
   * **************pledgeTV Forms JS Starts Here ********************
   ****************************************************************/
  
  /**
   * this event handles to create a new channel under a channel form group
   */
  $("#addchannelrows").click(function (e) {
    e.preventDefault();
    var bPath = $("#base_url_cnpc").val();
    if (cnpcChnlListValidate() == false || cnpcchnlStartDateValidate() == false || cnpcchnlEndDateValidate() == false) {
      return false;
    }
    var crowCount = $('#custchnlrows tr').length;
    var crowIndex = parseInt($("#cnpcchnl_counter").val());
    var cdownIndex = crowIndex - 1;
    if ($("#chnlenddate_" + cdownIndex).val() == "") {
      $("#chnlenddate_" + cdownIndex).next("p").remove();
      $("#chnlenddate_" + cdownIndex).after("<p class='cnpctext-danger'>End date is required</p>");
      return false;
    }
    if ($("#chnlenddate_" + cdownIndex).val() != "") {
      $("#chnlenddate_" + cdownIndex).next("p").remove();
    }
    if (validateChannelDates(cdownIndex)) {
      var crows = generateChannelTable(crowIndex);
      $("tbody#dynachnlrows").append(crows);
      var chksdt = $("#chnlenddate_" + cdownIndex).val();

      $(".cnpcstartdate").each(function () {
        $(this).datetimepicker({
          timeFormat: 'hh:mm tt',
          dateFormat: 'MM dd, yy',
        });
      });
      $(".cnpcenddate").each(function () {
        $(this).datetimepicker({
          timeFormat: 'hh:mm tt',
          dateFormat: 'MM dd, yy',
        });
      });
      if (crowCount >= 2) {
        $(".deleteRec").show();
      } else {
        $(".deleteRec").hide();
      }
      getDataChannelService(crowIndex);
      $("#cnpcchnl_counter").val(crowIndex + 1);
    }
  });
  
  /**
   * This method validates the start date and End date of channel form group
   * we can not select previous date of current date
   * start date and end date should be greater than the current date always
   * end date should not below the start date
   * @param {type} j
   * @returns {Boolean}
   */
  function validateChannelDates(j) {
    var status = true;
    var strtdt1 = $("#chnlstartdate_" + j).val();
    var chkedt1 = $("#chnlenddate_" + j).val();
    var stdt = $("#start_date_time").val();
    var eddt = $("#end_date_time").val();
    var greg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
    if (stdt.match(greg)) {
      var gres = stdt.split(" ");
      var gres1 = gres[0].split("/");
      var gres2 = gres1[1] + "/" + gres1[0] + "/" + gres1[2];
      stdt = gres2 + " " + gres[1] + " " + gres[2];
    }
    if (eddt != "") {
      if (eddt.match(greg)) {
        var gcres = eddt.split(" ");
        var gcres1 = gcres[0].split("/");
        var gcres2 = gcres1[1] + "/" + gcres1[0] + "/" + gcres1[2];
        eddt = gcres2 + " " + gcres[1] + " " + gcres[2];
      }
    }
    var mstdt = new Date(stdt);
    var meddt = new Date(eddt);
    var ereg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
    if (strtdt1.match(ereg)) {
      var eres = strtdt1.split(" ");
      var eres1 = eres[0].split("/");
      var eres2 = eres1[1] + "/" + eres1[0] + "/" + eres1[2];
      strtdt1 = eres2 + " " + eres[1] + " " + eres[2];
    }
    if (chkedt1 != "") {
      if (chkedt1.match(ereg)) {
        var ecres = chkedt1.split(" ");
        var ecres1 = ecres[0].split("/");
        var ecres2 = ecres1[1] + "/" + ecres1[0] + "/" + ecres1[2];
        chkedt1 = ecres2 + " " + ecres[1] + " " + ecres[2];
      }
    }
    var mchksdt1 = new Date(strtdt1);
    var mchkedt1 = new Date(chkedt1);
    if (strtdt1 != "" && chkedt1 == "") {
      if (mchksdt1.getTime() < mstdt.getTime()) {
        $("#chnlstartdate_" + j).next().remove();
        $("#chnlstartdate_" + j).after("<p class='cnpc-danger'>Form start date should be greater or equal to group start date</p>");
        $("#chnlstartdate_" + j).focus();
        status = false;
      }
      if (mchksdt1.getTime() > meddt.getTime()) {
        $("#chnlstartdate_" + j).next().remove();
        $("#chnlstartdate_" + j).after("<p class='cnpc-danger'>Form start date should be less than or equal to group end date</p>");
        $("#chnlstartdate_" + j).focus();
        status = false;
      }
    }
    if (strtdt1 != "" && chkedt1 != "") {
      if (mchkedt1.getTime() > meddt.getTime()) {
        $("#chnlenddate_" + j).next().remove();
        $("#chnlenddate_" + j).after("<p class='cnpc-danger'>Form end date should be less than or equal to group end date</p>");
        $("#chnlenddate_" + j).focus();
        status = false;
      }
      if (mchksdt1.getTime() < mstdt.getTime()) {
        $("#chnlstartdate_" + j).next().remove();
        $("#chnlstartdate_" + j).after("<p class='cnpc-danger'>Form start date should be greater or equal to group start date</p>");
        $("#chnlstartdate_" + j).focus();
        status = false;
      }
      if (mchksdt1.getTime() > mchkedt1.getTime()) {
        $("#chnlenddate_" + j).next().remove();
        $("#chnlenddate_" + j).after("<p class='cnpc-danger'>End date should be greater than or equal to start date</p>");
        $("#chnlenddate_" + j).focus();
        status = false;
      }
    }
    return status;
  }

   /**
    * Method to validate the each and every channels drop down under a channel group
    * @returns {Boolean}
    */
  function cnpcChnlListValidate() {
    var stopper = true;
    if ($("#cnpc_action").val() == "edit") {
      $("select[name^='cnpc_chnl_list_']").each(function () {
        if ($(this).val() == "") {
          $("#" + $(this).attr("id")).next().remove();
          $("#" + $(this).attr("id")).after("<p class='cnpctext-danger'>Please select a channel</p>");
          stopper = false;
        } else {
          $("#" + $(this).attr("id")).next().remove();
        }
      });
    }
    var inps1 = document.getElementsByName('cnpc_chnl_list[]');
    for (var k = 0; k < inps1.length; k++) {
      if (inps1[k].value == "") {
        $("#" + inps1[k].id).next().remove();
        $("#" + inps1[k].id).after("<p class='cnpctext-danger'>Please select a channel</p>");
        stopper = false;
        break;
      } else {
        $("#" + inps1[k].id).next().remove();
      }
    }
    return stopper;
  }

  /**
   * Method for validating start date of each and every form in channel group
   * @returns {Boolean}
   */
  function cnpcchnlStartDateValidate() {
    var stopper = true;
    if ($("#cnpc_action").val() == "edit") {
      $("input[name^='chnlstartdate_']").each(function () {
        if ($(this).val() == "") {
          $("#" + $(this).attr("id")).next().remove();
          $("#" + $(this).attr("id")).after("<p class='cnpctext-danger'>Please select a start date</p>");
          stopper = false;
        } else {
          $("#" + $(this).attr("id")).next().remove();
        }
      });
    }
    var inps1 = document.getElementsByName('chnlstartdate[]');
    for (var k = 0; k < inps1.length; k++) {
      if (inps1[k].value == "") {
        $("#" + inps1[k].id).next().remove();
        $("#" + inps1[k].id).after("<p class='cnpctext-danger'>Please select a start date</p>");
        stopper = false;
        break;
      } else {
        $("#" + inps1[k].id).next().remove();
      }
    }
    return stopper;
  }
  
  /**
   * Method for validating end date of each and every form in channel group
   * @returns {Boolean}
   */
  function cnpcchnlEndDateValidate() {
    var stopper = true;
    if ($("#cnpc_action").val() == "edit") {
      $("input[name^='chnlenddate_']").each(function () {
        if ($(this).val() == "") {
          $("#" + $(this).attr("id")).next().remove();
          $("#" + $(this).attr("id")).after("<p class='cnpctext-danger'>Please select a end date</p>");
          stopper = false;
        } else {
          $("#" + $(this).attr("id")).next().remove();
        }
      });
    }
    var inps1 = document.getElementsByName('chnlenddate[]');
    for (var k = 0; k < inps1.length; k++) {
      if (k != 0) {
        if (inps1[k].value == "") {
          if (k == (inps1.length - 1)) {
            $("#" + inps1[k].id).next().remove();
            stopper = true;
          } else {
            $("#" + inps1[k].id).next().remove();
            $("#" + inps1[k].id).after("<p class='cnpctext-danger'>Please select a end date</p>");
            stopper = false;
            break;
          }
        }
      }
    }
    return stopper;
  }
  
  /**
   * get all the channels to display in the channels dropdown 
   * @param {type} ind
   * @returns {undefined}
   */
  function getDataChannelService(ind) {
    var accguid = $("#cnpc_accounts").val();
    var obj = accguid.split("||");
    let accid = obj[0];
    let guid = obj[1];
    let finalguid = accid + "@" + guid;
    var basePath = $("#base_url_cnpc").val();
    var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/getchannels/" + finalguid;
    $.ajax({
      type: "GET",
      url: url,
      beforeSend: function () {
        $("#imgloader_" + ind).show();
      },
      success: function (res) {
        $("#cnpc_chnl_list_" + ind).html(res.data);
        $("#imgloader_" + ind).hide();
      },
      error: function (err) {
        alert("Unable to get the channels");
      }
    });
  }
  
  /**
   * This event handles basic validations of Add new Channel form like date and time validations,data validation
   * after it will save the Channel form data into database table
   */
  $("#finalchnlsave").click(function () {
    if ($("#cnpc_channel_group_name").val() == "") {
      $("#cnpc_channel_group_name").css("border", "1px solid red");
      $("#cnpc_channel_group_name").focus();
      return false;
    } else {
      $("#cnpc_channel_group_name").css("border", "1px");
    }
    if ($("#start_date_time").val() == "") {
      $("#start_date_time").css("border", "1px solid red");
      $("#start_date_time").focus();
      return false;
    }
    var stdt = $("#start_date_time").val();
    var eddt = $("#end_date_time").val();
    var greg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
    var mstdt = new Date(stdt);
    var meddt = new Date(eddt);
    var chksdt = $("#start_date_time").val();
    var chkedt = $("#end_date_time").val();
    var reg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
    if (chksdt.match(reg)) {
      var res = chksdt.split(" ");
      var res1 = res[0].split("/");
      var res2 = res1[1] + "/" + res1[0] + "/" + res1[2];
      chksdt = res2 + " " + res[1] + " " + res[2];
    }
    if (chkedt != "") {
      if (chkedt.match(reg)) {
        var cres = chkedt.split(" ");
        var cres1 = cres[0].split("/");
        var cres2 = cres1[1] + "/" + cres1[0] + "/" + cres1[2];
        chkedt = cres2 + " " + cres[1] + " " + cres[2];
      }
    }
    var mchksdt = new Date(chksdt);
    var mchkedt = new Date(chkedt);
    if ($("#start_date_time").val() == "") {
      $("#start_date_time").addClass("cnpcform-invalid");
      $("#start_date_time").focus();
      return false;
    }
    if (chksdt != "" && chkedt != "") {
      if (mchksdt.getTime() > mchkedt.getTime()) {
        $("#end_date_time").addClass("cnpcform-invalid");
        $("#end_date_time").focus();
        return false;
      }
    }
    var camp = cnpcChnlListValidate();
    var sdate = cnpcchnlStartDateValidate();
    var edate = cnpcchnlEndDateValidate();
    var nofrms = $("#cnpcchnl_counter").val();
    nofrms = nofrms - 1;
    for (var j = 0; j <= nofrms; j++) {
      var strtdt1 = $("#chnlstartdate_" + j).val();
      var chkedt1 = $("#chnlenddate_" + j).val();
      var ereg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
      if (strtdt1.match(ereg)) {
        var eres = strtdt1.split(" ");
        var eres1 = eres[0].split("/");
        var eres2 = eres1[1] + "/" + eres1[0] + "/" + eres1[2];
        strtdt1 = eres2 + " " + eres[1] + " " + eres[2];
      }
      if (chkedt1 != "") {
        if (chkedt1.match(ereg)) {
          var ecres = chkedt1.split(" ");
          var ecres1 = ecres[0].split("/");
          var ecres2 = ecres1[1] + "/" + ecres1[0] + "/" + ecres1[2];
          chkedt1 = ecres2 + " " + ecres[1] + " " + ecres[2];
        }
      }
      var mchksdt1 = new Date(strtdt1);
      var mchkedt1 = new Date(chkedt1);
      if (strtdt1 != "" && chkedt1 == "") {
        if (mchksdt1.getTime() < mstdt.getTime()) {
          $("#chnlstartdate_" + j).next().remove();
          $("#chnlstartdate_" + j).after("<p class='cnpctext-danger'>Channel start date should be greater or equal to group start date</p>");
          $("#chnlstartdate_" + j).focus();
          return false;
        }
        if (mchksdt1.getTime() > meddt.getTime()) {
          $("#chnlstartdate_" + j).next().remove();
          $("#chnlstartdate_" + j).after("<p class='cnpctext-danger'>Channel start date should be less than or equal to group end date</p>");
          $("#chnlstartdate_" + j).focus();
          return false;
        }
      }
      if (strtdt1 != "" && chkedt1 != "") {
        if (mchkedt1.getTime() > meddt.getTime()) {
          $("#chnlenddate_" + j).next().remove();
          $("#chnlenddate_" + j).after("<p class='cnpctext-danger'>Channel end date should be less than or equal to group end date</p>");
          $("#chnlenddate_" + j).focus();
          return false;
        }
        if (mchksdt1.getTime() < mstdt.getTime()) {
          $("#chnlstartdate_" + j).next().remove();
          $("#chnlstartdate_" + j).after("<p class='cnpctext-danger'>Channel start date should be greater or equal to group start date</p>");
          $("#chnlstartdate_" + j).focus();
          return false;
        }
        if (mchksdt1.getTime() > mchkedt1.getTime()) {
          $("#chnlenddate_" + j).next().remove();
          $("#chnlenddate_" + j).after("<p class='cnpctext-danger'>End date should be greater than or equal to start date</p>");
          $("#chnlenddate_" + j).focus();
          return false;
        }
      }
    }
    if (camp && sdate && edate) {
      var form_data = new FormData();
      var cnpcfgn = $("#cnpc_channel_group_name").val();
      var cnpcsdt = $("#start_date_time").val();
      var cnpcedt = $("#end_date_time").val();
      var cmpcmsg = $("#cnpc_message").val();
      var status = $("#cnpc_status").val();
      var formAction = $("#cnpc_action").val();
      var cnpcacc = $("#cnpc_accounts").val();
      form_data.append('cnpc_action', formAction);
      form_data.append('cnpc_group_name', cnpcfgn);
      form_data.append('cnpc_start_datetime', cnpcsdt);
      form_data.append('cnpc_end_datetime', cnpcedt);
      form_data.append('cnpc_account', cnpcacc);
      form_data.append('cnpc_message', cmpcmsg);
      form_data.append('cnpc_status', status);
      var basePath = $("#base_url_cnpc").val();
      var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/savechanneldata/";
      if (formAction == "add") {
        var camp_list = getValues("cnpc_chnl_list[]");;
        var startdate = getValues("chnlstartdate[]");
        var enddate = getValues("chnlenddate[]");
      } else {
        var camp_list = getFormSelectValues("cnpc_chnl_list");
        var startdate = getFormValues("chnlstartdate");
        var enddate = getFormValues("chnlenddate");
        var cnpc_edit_id = $("#cnpc_edit_id").val();
        form_data.append("cnpc_edit_id", cnpc_edit_id);
      }
      form_data.append("cnpc_chnl_list", camp_list);
      form_data.append("chnlstartdate", startdate);
      form_data.append("chnlenddate", enddate);
      $.ajax({
        url: url,
        data: form_data,
        cache: false,
        contentType: false,
        method: 'POST',
        processData: false,
        dataType: 'json',
        success: function (res) {
          console.log(res.data);
          if (res.data == "success") {
            if (formAction == "edit") {
              window.location = "../CnPpledgeTVChannels";
            } else {
              window.location = "CnPpledgeTVChannels";
            }
          }
          return false;
        },
        error: function (res) {
          alert("Unable to insert channel data")
        },
      });
    }
    return false;
  });
  
  /**
   * Delete the channel information using ajax, once channel deleted successfully then it will redirects to
   * all channels view
   */
  $(".deletechannelInfo").click(function (e) {
    e.preventDefault();
    var did = $(this).data("recid");
    var basePath = $("#base_url_cnpc").val();
    var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/deletechannel/" + did;
    $.ajax({
      url: url,
      type: "GET",
      success: function (res) {
        if (res.data == "success") {
          window.location = "CnPpledgeTVChannels";
        } else {
          window.location = "CnPpledgeTVChannels";
        }
      },
      error: function (err) {
        alert("Unable to delete channel");
      },
    });
  });
  
/**
 * this function calls when user clicks Add Channel button, it will add more no.of channels under a campaign
 * @param {type} rowIndex
 * @returns {String}
 */
  function generateChannelTable(rowIndex) {
    var bPath = $("#base_url_cnpc").val();
    var trow = "";
    trow += "<tr id='row_" + rowIndex + "'>";
    trow += "<td>";
    trow += "<select  class='cnpc_chnl_list' data-rowindex='" + rowIndex + "'  name='cnpc_chnl_list[]' id='cnpc_chnl_list_" + rowIndex + "'>";
    trow += "<option value=''>Select Channel</option>";
    trow += "</select><img id='imgloader_" + rowIndex + "' src='" + bPath + "modules/clickandpledge_connect/images/loading.gif' height='25' width='25'>";
    trow += "</td>";
    trow += "<td>";
    trow += "<input type='text' name='chnlstartdate[]' class='cnpcstartdate' id='chnlstartdate_" + rowIndex + "'>";
    trow += "</td>";
    trow += "<td>";
    trow += "<input type='text' name='chnlenddate[]' class='cnpcenddate' id='chnlenddate_" + rowIndex + "'>";
    trow += "</td>";
    trow += "<td id='row_" + rowIndex + "'>";
    trow += "<a href='javascript:void(0)' id='deleteRec_" + rowIndex + "' data-target='add' class='deleteRec' data-index='" + rowIndex + "'><span class='bin_icon'></span></a>";
    trow += "</td>";
    trow += "</tr>";
    return trow;
  }
  
  /**
   * the below action handles the Add New Channel form validation. if this form is valid,then it allows
   * to add the campaign forms
   */
  $("#chnlsavebtn").click(function () {
    if ($("#cnpc_action").val() == "add") {
      var fs = verifyChannelGroupName($("#cnpc_channel_group_name").val());
      if (fs >= 1) {
        $(".cnpc_channelexists_error").html("Channel group name already exist");
        $("#chnlsavebtn").attr("disabled", "disabled");
        $("#cnpc_channel_group_name").focus();
      } else {
        $(".cnpc_channelexists_error").html("");
        $("#chnlsavebtn").removeAttr("disabled");
      }
    } else if ($("#cnpc_action").val() == "edit") {
      if ($("#hidden_fg_name").val() != $("#cnpc_channel_group_name").val()) {
        var fs = verifyFormGroupName($("#cnpc_channel_group_name").val());
        if (fs >= 1) {
          $(".cnpc_channelexists_error").html("Channel group name already exist");
          $("#finalchnlsave").attr("disabled", "disabled");
        } else {
          $(".cnpc_channelexists_error").html("");
          $("#finalchnlsave").removeAttr("disabled");
        }
      } else {
        $(".cnpc_channelexists_error").html("");
        $("#finalchnlsave").removeAttr("disabled");
      }
    }
    var stdt = $("#start_date_time").val();
    var eddt = $("#end_date_time").val();
    var greg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
    if (stdt.match(greg)) {
      var gres = stdt.split(" ");
      var gres1 = gres[0].split("/");
      var gres2 = gres1[1] + "/" + gres1[0] + "/" + gres1[2];
      stdt = gres2 + " " + gres[1] + " " + gres[2];
    }
    if (eddt != "") {
      if (eddt.match(greg)) {
        var gcres = eddt.split(" ");
        var gcres1 = gcres[0].split("/");
        var gcres2 = gcres1[1] + "/" + gcres1[0] + "/" + gcres1[2];
        eddt = gcres2 + " " + gcres[1] + " " + gcres[2];
      }
    }
    var mstdt = new Date(stdt);
    var meddt = new Date(eddt);
    if ($("#cnpc_channel_group_name").val() == "") {
      $("#cnpc_channel_group_name").css("border", "1px solid red");
      $("#cnpc_channel_group_name").focus();
      return false;
    } else {
      $("#cnpc_channel_group_name").css("border", "1px");
    }
    if ($("#start_date_time").val() == "") {
      $("#start_date_time").css("border", "1px solid red");
      $("#start_date_time").focus();
      return false;
    }
    if (mstdt.getTime() > meddt.getTime()) {
      $("#start_date_time").css("border", "1px solid red");
      $("#start_date_time").focus();
      return false;
    }
    $(".cnpc_settings_form").show();
    getDataChannelService($("#cnpcchnl_counter").val());
    var tab = generateChannelTable($("#cnpcchnl_counter").val());
    $("tbody#dynachnlrows").append(tab);
    $(".cnpcstartdate").each(function () {
      $(this).datetimepicker({
        timeFormat: 'hh:mm tt',
        dateFormat: 'MM dd, yy',
      });
    });
    $(".cnpcenddate").each(function () {
      $(this).datetimepicker({
        timeFormat: 'hh:mm tt',
        dateFormat: 'MM dd, yy',
      });
    });
    $("#chnlsavebtn").hide();
    $("#resetbtn").hide();
    $(".cnpc_hide_show_buttons").show();
    $("#cnpcchnl_counter").val(1);
    return false;
  });
  
  /**
   * Handing with a tooltip in connect forms view table, when we kept mouse on question  mark, opens a tooltip 
   * which guides how to use short code
   */
  $(".cnpc_question").mouseover(function () {
    $(".cnpc_shortcode_tooltip").show();
  });
  $(".cnpc_question").mouseout(function () {
    $(".cnpc_shortcode_tooltip").hide();
  });
  $(".cnpc_shortcode_tooltip").mouseover(function () {
    $(this).show();
  });
  $(".cnpc_shortcode_tooltip").mouseout(function () {
    $(this).hide();
  });

  /**
   * validates the Connect Form for both Add and Edit
   * @returns {Boolean}
   */
  function validateBasicForm() {
    var status = true;
    if ($("#cnpc_action").val() == "add") {
      var fs = verifyFormGroupName($("#cnpc_form_group_name").val());
      if (fs >= 1) {
        $(".cnpc_formexists_error").html("Form group name already exist");
        $("#savebtn").attr("disabled", "disabled");
        $("#cnpc_form_group_name").focus();
      } else {
        $(".cnpc_formexists_error").html("");
        $("#savebtn").removeAttr("disabled");
      }
    } else if ($("#cnpc_action").val() == "edit") {
      if ($("#hidden_fg_name").val() != $("#cnpc_form_group_name").val()) {
        var fs = verifyFormGroupName($("#cnpc_form_group_name").val());
        if (fs >= 1) {
          $(".cnpc_formexists_error").html("Form group name already exist");
          $("#finalsave").attr("disabled", "disabled");
        } else {
          $(".cnpc_formexists_error").html("");
          $("#finalsave").removeAttr("disabled");
        }
      } else {
        $(".cnpc_formexists_error").html("");
        $("#finalsave").removeAttr("disabled");
      }
    }
    if ($("#cnpc_form_group_name").val() == "") {
      $("#cnpc_form_group_name").css("border", "1px solid red");
      $("#cnpc_form_group_name").focus();
      status = false;
    }
    var stdt = $("#start_date_time").val();
    var eddt = $("#end_date_time").val();
    var greg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
    if (stdt.match(greg)) {
      var gres = stdt.split(" ");
      var gres1 = gres[0].split("/");
      var gres2 = gres1[1] + "/" + gres1[0] + "/" + gres1[2];
      stdt = gres2 + " " + gres[1] + " " + gres[2];
    }
    if (eddt != "") {
      if (eddt.match(greg)) {
        var gcres = eddt.split(" ");
        var gcres1 = gcres[0].split("/");
        var gcres2 = gcres1[1] + "/" + gcres1[0] + "/" + gcres1[2];
        eddt = gcres2 + " " + gcres[1] + " " + gcres[2];
      }
    }
    var mstdt = new Date(stdt);
    var meddt = new Date(eddt);
    var campfldnm;
    var frmfldnm;
    var guidfldnm;
    var chksdt = $("#start_date_time").val();
    var chkedt = $("#end_date_time").val();
    var reg = /(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d/;
    if (chksdt.match(reg)) {
      var res = chksdt.split(" ");
      var res1 = res[0].split("/");
      var res2 = res1[1] + "/" + res1[0] + "/" + res1[2];
      chksdt = res2 + " " + res[1] + " " + res[2];
    }
    if (chkedt != "") {
      if (chkedt.match(reg)) {
        var cres = chkedt.split(" ");
        var cres1 = cres[0].split("/");
        var cres2 = cres1[1] + "/" + cres1[0] + "/" + cres1[2];
        chkedt = cres2 + " " + cres[1] + " " + cres[2];
      }
    }
    var mchksdt = new Date(chksdt);
    var mchkedt = new Date(chkedt);
    if ($("#start_date_time").val() == "") {
      $("#start_date_time").addClass("cnpcform-invalid");
      $("#start_date_time").focus();
      status = false;
    }
    if (chksdt != "" && chkedt != "") {
      if (mchksdt.getTime() > mchkedt.getTime()) {
        $("#end_date_time").addClass("cnpcform-invalid");
        $("#end_date_time").focus();
        status = false;
      }
    }
    //display type validation
    if ($("#cnpc_display_type").val() == "") {
      $("#cnpc_display_type").addClass("cnpcform-invalid");
      $("#cnpc_display_type").focus();
      status = false;
    }
    if ($("#cnpc_display_type").val() == "popup" && $("#cnpc_link_type").val() == "") {
      $("#cnpc_link_type").addClass("cnpcform-invalid");
      status = false;
    }
    if ($("#cnpc_display_type").val() == "popup" && ($("#cnpc_display_type").val() == "text" || $("#cnpc_display_type").val() == "button") && $("#cnpc_btn_lbl").val() == "") {
      $("#cnpc_btn_lbl").addClass("cnpcform-invalid");
      status = false;
    }
    var cnpcdtype = $("#cnpc_display_type").val();
    if (cnpcdtype == "popup") {
      var cnpcltype = $("#cnpc_link_type").val();
      if (cnpcltype == "image") {
        var filepath = $("#cnpc_upload_image").val();
        var files = document.getElementById('cnpc_upload_image').files;
        if (files.length != 0) {
          if (files[0].type == "image/png" || files[0].type == "image/jpg" || files[0].type == "image/jpeg") {
            $("#cnpc_upload_image").css("border", "1px solid rgb(184, 184, 184)");
          } else {
            $("#cnpc_upload_image").css("border", "1px solid red");
            $("#cnpc_upload_image").focus();
            status = false;
          }
        } else {
          if ($("#cnpc_action").val() == "edit") {
            var hiddenImg = $("#cnpc_upload_image_hidden").val();

          } else {
            $("#cnpc_upload_image").css("border", "1px solid red");
            $("#cnpc_upload_image").focus();
            status = false;
          }
        }
      } else {
        var btnlbl = $("#cnpc_btn_lbl").val();
        var linktype = $("#cnpc_link_type").val();
        if (btnlbl != "") {
          $("#cnpc_btn_lbl").css("border", "1px solid rgb(184, 184, 184)");
        } else {
          $("#cnpc_btn_lbl").css("border", "1px solid red");
          $("#cnpc_btn_lbl").focus();
          status = false;
        }
      }
    }
    return status;
  }
  
  /**
   * Verify the account number already exists in table or not
   * @param {type} number
   * @returns {undefined}
   */
  function verifyAccountNumber(number) {
    var basePath = $("#base_url_cnpc").val();
    var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/verifyaccnumber/" + number;
    $.ajax({
      type: "GET",
      url: url,
      success: function (res) {
        if (res >= 1) {
          $(".cnpc_exists_error").html("Account already exist.");
          $("input[value='Verify']").attr("disabled", "disabled");
          $("#cnpc_account_number").focus();
        } else {
          $(".cnpc_exists_error").html("");
          $("input[value='Verify']").removeAttr("disabled");
        }
      },
      error: function (err) {
        alert("Unable to verify account number")
      }
    });
  }
  
  /**
   * to verify the from group name for avoiding duplicate group names
   * @param {type} fname
   * @returns {res}
   */
  function verifyFormGroupName(fname) {
    var fStatus = null;
    var basePath = $("#base_url_cnpc").val();
    var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/verifyformgroupname/" + fname;
    $.ajax({
      type: "GET",
      url: url,
      cache: false,
      dataType: "html",
      async: false,
      success: function (res) {
        fStatus = res;
      }
    });
    return fStatus;
  }
  
  /**
   * to verify the channel group name for avoiding duplicate channel names
   * @param {type} fname
   * @returns {res}
   */
  function verifyChannelGroupName(fname) {
    var fStatus = null;
    var basePath = $("#base_url_cnpc").val();
    var url = location.protocol + "//" + location.host + basePath + "admin/clickandpledge_connect/verifychannelgroupname/" + fname;
    $.ajax({
      type: "GET",
      url: url,
      cache: false,
      dataType: "html",
      async: false,
      success: function (res) {
        fStatus = res;
      }
    });
    return fStatus;
  }
})(jQuery, Drupal);