<?php

namespace Drupal\clickandpledge_connect\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Form\FormBase;

/**
 * to view all the forms under a channel
 */
class ViewChannels extends FormBase
{
    /**
     * Construct
     */
    private $connection;
    public function __construct(){
        $this->connection=\Drupal::database();
    }
  /**
    * {@inheritdoc}
  */
  public function getFormId()
  {
    return "cnpcaccount_viewchannels";
  }
  
  /**
    * {@inheritdoc}
  */
  public function buildForm(array $form, FormStateInterface $form_state)
  {
    /*if(count($this->getChannelName(15))>0)
    {
      $settID = $this->getChannelName(15);
      $settID = $settID[0]->cnpchannelgrp_cnpstngs_ID;
      //echo $settID;
    }*/
    $form = $this->displayAccountSettingsForm($form, $form_state);
    return $form;
  }
  
  /**
   * displayAccountSettingsForm
   * creates a table to display the campaign forms under channel group
   * @param type $form
   * @param type $form_state
   * @return string
   */
  public function displayAccountSettingsForm($form, $form_state)
  {
    $form['base_url_cnpc'] = [
      '#type' => 'hidden',
      '#default_value' => base_path(),
      '#attributes' => ["id" => "base_url_cnpc"],
    ];
    $form['cnpc_menu'] = [
      '#prefix' => '<div class="cnp_heading"><ul>'
        . '<li><a href="../cnp_form_help">'.$this->t("Click & Pledge").'</a></li>'
        . '<li><a href="../cnp_form">'.$this->t("Form Groups").'</a></li>'
        . '<li><a class="cnpccurrent" href="../cnppledgetvchannels">'.$this->t("pledgeTV").'<sup class="cnpc-regsymbol">&reg;</sup></a></li>'
        . '<li><a href="../cnp_formssettings">'.$this->t("Settings").'</a></li>'
        . '</ul>',
      '#suffix' => '</div>',
    ];
    $path = \Drupal::request()->getpathInfo();
    $arg  = explode('/', $path);
    $reqID = end($arg);
    $prefix = $this->connection->tablePrefix();
    $table_name = $prefix . 'dp_cnpc_channeldtl';
    $sql = "SELECT cnpchannel_id,cnpchannel_cnpchannelgrp_ID,cnpchannel_channelName,cnpchannel_channelStartDate,"
            . "cnpchannel_channelEndDate,cnpchannel_channelStatus,cnpchannel_DateCreated,"
            . "cnpchannel_DateModified FROM " . $table_name . " where cnpchannel_cnpchannelgrp_ID=" . $reqID;
    $query = $this->connection->query($sql);
    $allForms = $query->fetchAll();
    $form['cnpc_heading'] = [
      '#prefix' => '<div class="cnp_heading1">',
      '#suffix' => '</div>',
    ];
    $html = '<a href="../cnppledgetvchannels" class="cnpc_button_link_edit">'.$this->t("Go back to Channel Groups").'</a>';
    $form['gobackbtn_link_html'] = [
      '#type' => 'markup',
      '#markup' => $html,
    ];
    $form['table_group_start'] = [
      "#prefix" => "<div class='tablelist_group'>",
    ];
    if (count($allForms) > 0) {
      $form['table_tag_start'] = [
        "#prefix" => "<div><table id='table_viewforms' class='table_viewforms'>
                            <thead>
                                <tr>
                                    <th>".$this->t("ID")."</th>
                                    <th>".$this->t("Channel Name")."</th>
                                    <th>".$this->t("Start Date/Time")."</th>
                                    <th>".$this->t("End Date/Time")."</th>
                                </tr>
                            </thead>
                            <tbody>"
      ];
      $rg = 1;
      foreach ($allForms as $fg) {
        if ($fg->cnpchannel_channelEndDate == "0000-00-00 00:00:00") {
          $enddate = "";
        } else {
          $enddate = date("F d, Y h:i:s a", strtotime($fg->cnpchannel_channelEndDate));
        }
        $form['table_row_form_groups_' . $rg] = [
          "#prefix" => "<tr>
                                   <td>" . $fg->cnpchannel_id . "</td>
                                   <td>" . $fg->cnpchannel_channelName . "</td>
                                   <td>" . date("F d, Y h:i:s a", strtotime($fg->cnpchannel_channelStartDate)) . "</td>
                                   <td>" . $enddate . "</td>",
          "#suffix" => "</tr>",
        ];
        $rg++;
      }
      $form['table_tag_end'] = [
        "#suffix" => "</tbody>
                       </table></div>",
      ];
    } else {
      $form['no_records'] = [
        "#prefix" => "<div><p>".$this->t("No Records Found.")."</p>",
        "#suffix" => "</div>",
      ];
    }
    $form['table_group_end'] = [
      "#suffix" => "</div>",
    ];
    return $form;
  }
  
 /**
  * {@inheritdoc}
  */
  public function validateForm(array &$form, FormStateInterface $form_state)
  {
    //form validations are hasling with javascript
  }
  
 /**
    * {@inheritdoc}
  */
  public function submitForm(array &$form, FormStateInterface $form_state)
  {
    //this class is for displaying the forms list under a channel group
  }
  public function getChannelName($id){
      //cnpchannelgrp_ID
    $prefix = $this->connection->tablePrefix();
    $table_name1 = $prefix . 'dp_cnpc_channelgrp';
    $table_name2 = $prefix . 'dp_cnpc_channeldtl';
    $sql="select ".$table_name2.".cnpchannel_cnpchannelgrp_ID,".$table_name2.".cnpchannel_id,".$table_name1.".cnpchannelgrp_ID, ".$table_name1.".cnpchannelgrp_cnpstngs_ID from ".$table_name2." JOIN ".$table_name1." ON ".$table_name1.".cnpchannelgrp_ID = ".$table_name2.".cnpchannel_cnpchannelgrp_ID where ".$table_name2.".cnpchannel_id =".$id;
    $query = $this->connection->query($sql);
    $allForms = $query->fetchAll();
    return $allForms;
  }
  
}
