<?php

namespace Drupal\clickandpledge_connect\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Form\FormBase;

/**
 * to view all the forms under a CONNECT campaign
 */
class ViewForms extends FormBase
{
  /**
    * {@inheritdoc}
  */
  public function getFormId()
  {
    return "cnpcaccount_viewforms";
  }
  
  /**
    * {@inheritdoc}
  */
  public function buildForm(array $form, FormStateInterface $form_state)
  {
    $form = $this->displayAccountSettingsForm($form, $form_state);
    return $form;
  }
  
  /**
    * {@inheritdoc}
  */
  public function displayAccountSettingsForm($form, $form_state)
  {
    $form['base_url_cnpc'] = [
      '#type' => 'hidden',
      '#default_value' => base_path(),
      '#attributes' => ["id" => "base_url_cnpc"],
    ];
    $form['cnpc_menu'] = [
      '#prefix' => '<div class="cnp_heading"><ul>'
        . '<li><a href="../cnp_form_help">'.$this->t("Click & Pledge").'</a></li>'
        . '<li><a href="../cnp_form" class="cnpccurrent">'.$this->t("Form Groups").'</a></li>'
        . '<li><a href="../cnppledgetvchannels">'.$this->t("pledgeTV").'<sup class="cnpc-regsymbol">&reg;</sup></a></li>'
        . '<li><a href="../cnp_formssettings">'.$this->t("Settings").'</a></li>'
        . '</ul>',
      '#suffix' => '</div>',
    ];
    $path = \Drupal::request()->getpathInfo();
    $arg  = explode('/', $path);
    $reqID = end($arg);
    $connection = \Drupal::database();
    $prefix = $connection->tablePrefix();
    $table_name = $prefix . 'dp_cnpc_formsdtl';
    $sql = "SELECT cnpform_id,cnpform_cnpform_ID,cnpform_CampaignName,cnpform_FormName,cnpform_GUID,"
            . "cnpform_FormStartDate,cnpform_FormEndDate,cnpform_urlparameters,cnpform_FormStatus,"
            . "cnpform_DateCreated,cnpform_DateModified FROM " . $table_name . " where "
            . "cnpform_cnpform_ID=" . $reqID;
    $query = $connection->query($sql);
    $allForms = $query->fetchAll();
    $html = '<a href="../cnp_form"  class="cnpc_button_link_edit">'.$this->t("Go back to Form Groups").'</a>';
    $form['gobackbtn_link_html'] = [
      '#type' => 'markup',
      '#markup' => $html,
    ];
    $form['cnpc_heading'] = [
      '#prefix' => '<div class="cnp_heading1">',
      '#suffix' => '</div>',
    ];
    $form['table_group_start'] = [
      "#prefix" => "<div class='tablelist_group'>",
    ];
    if (count($allForms) > 0) {
      $form['table_tag_start'] = [
        "#prefix" => "<div><table id='table_viewforms' class='table_viewforms'>
                        <thead>
                            <tr>
                                <th>".$this->t("ID")."</th>
                                <th>".$this->t("Campaign Name")."</th>
                                <th>".$this->t("Form Name")."</th>
                                <th>".$this->t("GUID")."</th>
                                <th>".$this->t("Start Date/Time")."</th>
                                <th>".$this->t("End Date/Time")."</th>
                            </tr>
                        </thead>
                            <tbody>"
      ];
      $rg = 1;
      foreach ($allForms as $fg) {
        if ($fg->cnpform_FormEndDate == "0000-00-00 00:00:00") {
          $enddate = "";
        } else {
          $enddate = date("F d, Y h:i:s a", strtotime($fg->cnpform_FormEndDate));
        }
        $form['table_row_form_groups_' . $rg] = [
          "#prefix" => "<tr>
                                   <td>" . $fg->cnpform_id . "</td>
                                   <td>" . $fg->cnpform_CampaignName . "</td>
                                   <td>" . $fg->cnpform_FormName . "</td>
                                   <td>" . $fg->cnpform_GUID . "</td>
                                   <td>" . date("F d, Y h:i:s a", strtotime($fg->cnpform_FormStartDate)) . "</td>
                                   <td>" . $enddate . "</td>",
          "#suffix" => "</tr>",
        ];
        $rg++;
      }
      $form['table_tag_end'] = [
        "#suffix" => "</tbody>
                       </table></div>",
      ];
    } else {
      $form['no_records'] = [
        "#prefix" => "<div><p>".$this->t("No Records Found.")."</p>",
        "#suffix" => "</div>",
      ];
    }
    $form['table_group_end'] = [
      "#suffix" => "</div>",
    ];
    return $form;
  }
  
  /**
    * {@inheritdoc}
  */
  public function validateForm(array &$form, FormStateInterface $form_state)
  {
    //form validations are hasling with javascript
  }
  
  /**
    * {@inheritdoc}
  */
  public function submitForm(array &$form, FormStateInterface $form_state)
  {
    //this class is for displaying the form list under a connect campaign
  }
  
}
